// Counter.java

import java.awt.GridLayout;
import java.awt.event.*;
import javax.swing.*;
import java.util.Random;
import java.net.URL;

public class TickTackToeApp extends JApplet implements ActionListener {

    // Variables

    int Counter, NumPlayers, player;
    int[][] board = new int[4][4];
    int[] player_counter = new int[3];
    ImageIcon[] pic = new ImageIcon[3];
    JPanel pane;
    JLabel lab;
    JButton[] btn = new JButton[10];
    String[] CntOpt = {"Naught", "Cross"};  
    String[] PlayOpt = {"1 Player", "2 Players"};

    // Constants
    final int WIN=1,DONE=2,FULL=3;

  // Initialise program here as there is no main subroutine
  public void init() 
  {
	java.net.URL location;

	try {
	 location = new URL("http://localhost/Blank.gif");
         pic[0] = new ImageIcon(location);
	 location = new URL("http://localhost/Naught.gif");
         pic[1] = new ImageIcon(location);
	 location = new URL("http://localhost/Cross.gif");
         pic[2] = new ImageIcon(location);
 	} catch (Exception e)
    	{ System.out.println("Unable to load images"); 
	  System.exit(0); }

       // Player one = Naughts or Crosses?       
       Counter = 1 + JOptionPane.showOptionDialog(null, "Select Counter?", "Counter", 0,
         JOptionPane.QUESTION_MESSAGE, null, CntOpt ,CntOpt[0]);

       if (Counter==1) {
          player_counter[1] = 1;
          player_counter[2] = 2;
       }
       else {
          player_counter[1] = 2;
          player_counter[2] = 1;
       }
       
       // 1 or 2 Players? (Dialog returns 0 or 1)
       NumPlayers = 1 + JOptionPane.showOptionDialog(null, "Select Number of Players?", "Players", 0,
         JOptionPane.QUESTION_MESSAGE, null, PlayOpt, PlayOpt[0]);

      pane = new JPanel();
      Clear_Board();
      Draw_Board();
      player = 1;

    }

    private void Draw_Board()
    {
	// Draw a 3x3 board

        pane.removeAll();

        // Create a 3 x 3 grid with 2 pixel gap
        pane.setLayout(new GridLayout(4,3,2,2));

        for(int n=1;n<=9;n++) {
          btn[n] = new JButton(pic[0]);
          btn[n].setSize(80,80);
          pane.add(btn[n]);
          btn[n].addActionListener(this);
        }
	// Add a label on botton row
        lab = new JLabel("New Game. Player 1 turn", SwingConstants.LEFT);
        pane.add(lab);
        setContentPane(pane);        
    }

    private void Clear_Board()
    {
        // Initialise board for a new game
        for (int r=1;r<=3;r++) {
          for (int c=1;c<=3;c++) {
            board[r][c]=0;
          }
        }
    }
    public void actionPerformed(ActionEvent e) 
    {
        Object src = e.getSource();

        // Change a specific button to O or X
        for (int n=1;n<=9;n++) {
         if (src == btn[n]) {
           Change_Button(btn[n], n);
           Change_Player();
         }
        }
    }
    private void Change_Button(JButton btn, int n)
    {
        int r,c;
        if (n>=7) {  // Convert n to r,c values
           r=3;
           c=n-6;
        }
        else if (n>=4) {
           r=2;
           c=n-3;
        } 
        else {
          r=1;
          c=n;
        }
        // Display a O or X and disable button from further use
        if (board[r][c] == 0) {
           btn.setIcon(pic[player_counter[player]]);
           btn.setEnabled(false);
           board[r][c] = player;
        }        
    }
    private void Change_Player()
    {
	// Check if a WIN or game board is full
	int result = Check_Board(player);
	if (result == WIN) {
		lab.setText(" Player " + String.valueOf(player) + " has WON!!");
		Disable_Board();
		New_Game();
		return ;
	}
	else if (result == FULL) {
		lab.setText("Game over. Board is full.");
		New_Game();
		return;
	}
	// Switch to next player
        if (player == 1) 
           player = 2;
        else
           player = 1;
	
	lab.setText ("Player " + String.valueOf(player) + " turn");

	// If CPU then let CPU play its turn
	if (NumPlayers==1 && player==2) 
	{
		result=CPU_turn(1,player);
		if (result == WIN) 
		{
			lab.setText (" Player " + String.valueOf(player) + " has WON!!");
			Disable_Board();
			New_Game();
		}
		else if (result == FULL) {
			lab.setText ("Game over. Board is full.");
			New_Game();
		}	
		player = 1;
		lab.setText ("Player " + String.valueOf(player) + " turn");		
    	}
    }
    private void New_Game()
    {
    	int n, result;

        result = JOptionPane.showConfirmDialog(null, "Play a new game?");
        if (result == JOptionPane.YES_OPTION) {
 		for (n=1;n<=9;n++) {
          	  btn[n].setIcon(pic[0]);
          	  btn[n].setEnabled(true);
        	}
        	player = 1;
		lab.setText ("Player " + String.valueOf(player) + " turn");
		Clear_Board();
	} 
 	else 
		System.exit(0);
     }
     private void Disable_Board()
     {
  		for (int n=1;n<=9;n++) {
          	  btn[n].setEnabled(false);
        	}
     }
     private boolean Is_Board_Full()
     {
		boolean full = true;
		for(int r=1;r<=3;r++) 
		{
			for(int c=1;c<=3;c++) 
			{
			   if (board[r][c]==0) 
				full=false;
			}
		}    
		return full;
	}
	private boolean Row_Win(int pl)
	{
		boolean win = false;
		int wincount, r, c;

		for (r=1; r<=3; r++) 
		{
			wincount=0;
			for (c=1; c<=3; c++) 
			{
				if (board[r][c]==pl) 
					wincount++;			
			}
			if (wincount==3) win=true;
		}
		return win;
	}
	private boolean Column_Win(int pl) 
	{
		boolean win=false;
		int wincount, r, c;

		for (c=1;c<=3; c++) 
		{
			wincount=0;
			for (r=1;r<=3;r++) 
			{
				if (board[r][c]==pl) 
					wincount++;
			}
			if (wincount==3) win=true;
		}
		return win;
	}
	private boolean Left_Right_Diag_Win(int pl)
	{
		boolean win=false;
		int wincount=0;
		int r=0;
		int c=0;
		for (int n=1;n<=3;n++) 
		{
			r++;
			c++;
			if (board[r][c]==pl)
				wincount++;
		}
		if (wincount==3) 
			win=true;
		return win;
	}
	private boolean Right_Left_Diag_Win(int pl)
	{
		boolean win=false;
		int wincount=0;
		int r=1;
		int c=3;
		for (int n=1;n<=3;n++) 
		{
			if (board[r][c] == pl) 
				wincount++;
			r++;
			c--;
		}
		if (wincount==3) 
			win=true;
		return win;
	}
	private   boolean CPU_Check_for_win_line(int pl) 
	{
		boolean win = false;
		for (int r=1; r<=3; r++) 
		{
			for (int c=1; c<=3; c++)  
			{
				if (board[r][c]==0)  
				{
					board[r][c]=pl;
					if (Row_Win(pl)) 
						win=true;
					else if (Column_Win(pl)) 
						win=true;
					else if (Left_Right_Diag_Win(pl)) 
						win=true;
					else if (Right_Left_Diag_Win(pl)) 
						win=true;
					else
						board[r][c]=0;
					if (board[r][c] != 0) 
					{
						Set_Board_Square(r,c,pl);
						return win;
					} // End if
				} // End if
			} // End for
		} // End for
		return(win);
	}
	private boolean check_for_win_line(int pl) 
	{
		boolean win;
		if (Row_Win(pl)) 
			win=true;
		else if (Column_Win(pl)) 
			win=true;
		else if (Left_Right_Diag_Win(pl)) 
			win=true;
		else if (Right_Left_Diag_Win(pl)) 
			win=true;
		else
			win=false;
		return(win);
	}
	private boolean check_for_opponent_near_win(int piece, int opponent_piece) 
	{  
		boolean block = false;
		for (int r=1; r<=3; r++)
		{
			for (int c=1; c<=3; c++)
			{
				if (board[r][c]==0) 
				{
					board[r][c]= opponent_piece;
					if (Row_Win(opponent_piece)) 
					{
						block=true;
						board[r][c]=piece;
					}
					else if (Column_Win(opponent_piece)) 
					{
						block=true;
						board[r][c]=piece;
					}
					else if (Left_Right_Diag_Win(opponent_piece)) 
					{
						block=true;
						board[r][c]=piece;
					}
					else if (Right_Left_Diag_Win(opponent_piece)) 
					{
						block=true;
						board[r][c]=piece;
					}
					else
						board[r][c]=0;
					if (board[r][c] != 0) 
					{
						Set_Board_Square(r,c,piece);
						return block;
					} // End if					
				} //  End if
			} // End for
		} // End for
		return(block);
	}
	private void Set_Random_Space(int pl)
	{
		int r,c;
		
		Random ran = new Random ();
		boolean done=false;
		int count=0;
		while (done==false && count<20) 
		{
			// Random number from 1 to 3
			r=ran.nextInt(3)+1;
			c=ran.nextInt(3)+1;
			if (board[r][c]==0) 
			{
				board[r][c]=pl;
				Set_Board_Square(r,c,pl);
				done = true;
			}
			else
				count++;

		}
	}
	private void Set_Board_Square(int r, int c, int pl)
	{
		int n;

		if (r==1) 
		{
			n = c;
                        btn[n].setIcon(pic[player_counter[pl]]);
                        btn[n].setEnabled(false);
                }	
		else if (r==2) 
		{
			n = 3 + c;
                        btn[n].setIcon(pic[player_counter[pl]]);
                        btn[n].setEnabled(false);
		}
		else 
		{
			n = 6 + c;
                        btn[n].setIcon(pic[player_counter[pl]]);
                        btn[n].setEnabled(false);
		}
	}
	private int CPU_turn(int human, int cpu) 
	{
		int result;

		if (Is_Board_Full())
			result = FULL;
		else 
			result = DONE;
		
		if (CPU_Check_for_win_line(cpu) == false) 
		{
			if (check_for_opponent_near_win(cpu,human) == false) {
				Set_Random_Space(cpu);
                                 result = Check_Board(cpu);
			}
		}
		else 
			result = WIN;
		
		return result;
							 
	}
	private int Check_Board(int pl)
	{
		int result;
		
		if (check_for_win_line(pl)) 
			result = WIN;
		else {
		    if (Is_Board_Full())
			result = FULL;
		    else
			result = DONE;
		}
		return result;				
	}
}

